; ---------------------------------------------
;  DOWN LOAD UTILITY PROGRAM
;
;       REV 1.0.0  BY  S.NAKAMURA  APR.24,1985
;       REV 1.0.1  BY  S.UMETA     AUG.03,1985
;
;         PRESENTED BY COMMODORE JAPAN LIMITED
; ---------------------------------------------
;
; ---------- DEFINES ----------
;
* =$003F
USRJMP *=*+2 ;WORK AREA
STATUS =$90
;
* =$00B7
FNLEN *=*+1 ;FILE NAME LENGTH
LA *=*+1 ;CULLENT LOGICAL ADDRESS
SA *=*+1 ;CULLENT SECONDALY ADDRESS
FA *=*+1 ;CULLENT FILE PRIMALY ADDRESS
;
* =$0B00
;
CMTBF *=*+1 ;CMT BUFFER
TARGET *=*+2 ;TARGET ADDRESS IN DISK
;
;ROM UTILITY ROUTINE
;
SNDLSN =$FFB1 ;SEND LISTEN
OUTIMM =$FF93 ;OUTPUT CHAR IMMIDIATE MODE TO IEEE
OUTPUT =$FFA8 ;OUTPUT CHAR DEFFER MODE TO IEEE
SNDUNL =$FFAE ;SEND UNLISTEN
SNDPRG =$F0CB ;SEND PROG.NAME TO IEEE
;
* =$3D00 ;START FROM HERE
;
 JMP START
;
;ARGUMENT AREA (USE POKE COMMAND FROM BASIC)
;
ORGAD .BYTE $00,$15 ;ORIGINAL ADDRESS
TAGT .BYTE $00,$04 ;TARGET ADDRESS
PAGES .BYTE $03 ;# OF PAGE TO SEND
DVSNUM .BYTE $08 ;DEVICE #
 .BYTE $26 ;WORK AREA
;
START LDA ORGAD
 STA USRJMP  ;LOAD ORIGINAL
 LDA ORGAD+1  ;ADDRESS TO SEND
 STA USRJMP+1  ;PROGRAM
;
 LDA TAGT  ;LOAD TARGET
 STA TARGET  ;ADDRESS TO SEND
 LDA TAGT+1  ;PROGRAM
 STA TARGET+1
;
 LDA PAGES  ;# OF PAGE WHICH
 STA CMTBF  ;WANT TO SEND
;
 LDA DVSNUM+1
 STA L027+1
;
MAINLP JSR SNDDSK
 LDA #'M  ;SEND COMMAND TO DISK
 STA CMTBF+3 ;'M-W'
 LDA #'-
 STA CMTBF+4
 LDA #'W
 STA CMTBF+5
;
L021 LDA TARGET ;SET LOW ADDRESS
 STA CMTBF+6 ;IN DISK MEMORY
 LDA TARGET+1 ;SET HIGH ADDRESS
 STA CMTBF+7 ;IN DISK MEMORY
 LDA TARGET
 CLC ;PREPARE TO SEND
 ADC #$20 ;NEXT 32 BYTES OF
 STA TARGET ;BLOCK FOR TARGET
 BCC L022
 INC TARGET+1 ;NEXT PAGE.
L022 LDA #$20 ;# OF BYTES
 STA CMTBF+8 ;TO SEND
 LDY #0 ;CLEAR COUNTER
L023 LDA (USRJMP),Y
 STA CMTBF+9,Y ;SET 32BYTES DATA
 INY ;IN CMT BUFFER
 CPY #$20
 BNE L023 ;SET DATA TILL 32BYTES
 JSR SDATA ;SEND DATA TO DISK
 LDA USRJMP
 CLC
 ADC #$20
 STA USRJMP ;SET NEXT 32BYTES
 BCC L021 ;BLOCK
 INC USRJMP+1
 DEC CMTBF
 BNE MAINLP
 RTS
;
;SEND DATA IN CMT BUFFER TO DISK
;
SDATA JSR L032
 LDY #0
L025 LDA CMTBF+3,Y
L026 JSR OUTPUT
 LDA STATUS
 BNE L029 ;DISK ERROR!
 INY
L027 CPY #42
 BNE L025
L028 JSR SNDUNL ;SEND UN-LISTEN
 RTS
;
L029 PLA
 PLA
 RTS
;
SNDDSK LDA #0
 STA STATUS ;CLEAR STATUS
 STA FNLEN ;SET FILE NAME LENGTH
 LDA #$6F ;SET SECONDARY ADD
 STA SA
 LDA DVSNUM ;SET DEVICE #
 STA FA
L031 JSR SNDPRG ;SEND PROGRAM NAME
L032 LDA FA
 JSR SNDLSN ;SEND LISTEN
 LDA SA
L034 JSR OUTIMM ;SEND SA
 RTS
;
 .END
