; PUT"@0:MFM-READ.ASM"
; ******************************
; *                            *
; * JTP044 REV 1.0.3 OCT.17,85 *
; *                            *
; ******************************
;
;
;
; ===  REV UP NOTES  ===
;
; @ REV 1.0.3
;   BURST READ ROUTINE ONLY
;   (CUT OTHER ROUTINES)
.PAGE
; ********************
; *                  *
; *    BURST READ    *
; *                  *
; * FOR MFM SOFT ERR *
; *                  *
; ********************
;
;
;
; **  KERNAL INDIRECT  **
;
SETLFS = $FFBA        ; SET LOGICAL FILE#,DEVICE#,CHANNEL#
SETNAM = $FFBD        ; SET LENGTH & ADDRESS OF FILENAME
OPEN   = $FFC0        ; OPEN LOGICAL FILE
CLOSE  = $FFC3        ; CLOSE LOGICAL FILE
ALCLOS = $FF4A        ; ALL CLOSE LOGICAL FILES
CHKIN  = $FFC6        ; SELECT CHANNEL FOR INPUT
CHKOUT = $FFC9        ; SELECT CHANNEL FOR OUTPUT
CLRCHN = $FFCC        ; CLEAR ALL CHANNEL & RESTORE DEFAULT I/O
CHRIN  = $FFCF        ; GET BYTE FROM CURRENT INPUT DEVICE
CHROUT = $FFD2        ; OUTPUT BYTE TO CURRENT OUTPUT DEVICE
;
SERIAL = $0A1C        ; FAST SERIAL FLAG
;
;
;
; * CIA #1 *  ($DC00-DC0F)
;
TALO   = $DC04        ; TIMER A LOW  REG
TAHI   = $DC05        ; TIMER A HIGH REG
D1SDR  = $DC0C        ; SERIAL DATA REGISTER
D1ICR  = $DC0D        ; INTERRUPT CONTROL REGISTER
D1CRA  = $DC0E        ; CONTROL REG A
;
; * CIA #2 *  ($DD00-DD0F)
;
D2PRA  = $DD00        ; PORTA CLK (INVERSED)
D2DDRA = $DD02        ; DDRA  CLK
.PAGE 'BUFFER'
; ********************
; *                  *
; *     BUFFER       *
; *                  *
; ********************
;
;
;
; ====================
;   READ BUFFER AREA
; ====================
;
 *=$0B00
;
BSTAT *=*+128    ;BUFF START 0-127
B128  *=*+128    ;128-255
B256  *=*+256    ;256-511
B512  *=*+512    ;512-1023
B1024 *=*        ;BUFF END
.PAGE
; ==============================
;    BASIC PARAMETER DEFINED
; ==============================
;
;
;
 *=$1800         ;***** NEVER CHANGE THE ORIGIN *****
;
;*** BURST READ ***
;
;IN  :
RDMFG  *=*+1     ;GCR/MFM FLAG
RFMSZ  *=*+1     ;MFM SECTOR SIZE
RDTRK  *=*+1     ;READ TRACK #
RDSEC  *=*+1     ;READ SECTOR #
RDSID  *=*+1     ;SIDE SELECT
;
;OUT :
STAUS  *=*+1     ;STATUS
RREAD  *=*+1     ;OK/NG FLAG
;
;
;
;*** BURST INQUIRE DISK ***
;
;IN  :
IQDSD  *=*+1     ;SIDE SELECT
;
;OUT :
DINQ   *=*+1     ;INQUIRE DATA
.PAGE 'MAIN'
; ********************
; *                  *
; *    BURST MAIN    *
; *                  *
; ********************
;
;
;
; ====================
;        READ
; ====================
;
ABC
 SEI        ;READ
 JSR OPDATC ;OPEN2,8,2,"#"
;
 JSR INQD  ;INQ
;
 JSR READ ;READ
;
 LDA #2 ;CLOSE2
 JSR CLOSE
;
 CLI
 RTS
.PAGE 'BURST READ'
; ++++++++++++++++++++++++++++++++++++++++
; +                                      +
; +    BURST READ SUB                    +
; +                                      +
; + IN  : RDMFG = $00 ... GCR (256 BYTE) +
; +             = $FF ... MFM            +
; +       RFMSZ =   1 ...  128 BYTE/SEC  +
; +             =   2 ...  256           +
; +             =   3 ...  512           +
; +             =   4 ... 1024           +
; +       RDTRK ...... READ TRK #        +
; +       RDSEC ...... READ SEC #        +
; +       RDSID ...... SIDE SEL (MFM)    +
; +                    $00=SIDE0         +
; +                    $10=SIDE1         +
; +                                      +
; + OUT : READ BUFFER (MAX.1024 BYTE)    +
; +       STAUS ...... STATUS BYTE       +
; +       RREAD = 0 ... OK               +
; +             = 1 ... ERROR            +
; +                                      +
; ++++++++++++++++++++++++++++++++++++++++
;
READ
 SEI
;
 LDA RDTRK       ;READ TRACK #
 STA CMBRD+4     ;CMD TBL SET
 LDA RDSEC       ;READ SECTOR #
 STA CMBRD+5     ;CMD TBL SET
 LDA CMBRD+3     ;SIDE SEL.
 AND #$EF        ;
 ORA RDSID       ;
 STA CMBRD+3     ;CMD TBL SET
;
;
 LDX RDMFG       ;CHECK GCR/MFM FLAG
 BEQ READ20      ;'GCR'
;
 LDY RFMSZ       ;CHECK MFM SECTOR SIZE
 DEY             ;=1 (MFM 128) ?
 BEQ READ10      ;YES
 DEY             ;=2 (MFM 256) ?
 BEQ READ20      ;YES
 DEY             ;=3 (MFM 512) ?
 BEQ READ30      ;YES
 BNE READ40      ;=4 (MFM 1024)
;
READ10
 LDX #$80        ;MFM 128
 LDY #$00
 JMP READ50
READ20           ;MFM/GCR 256
 LDX #$00
 LDY #$01
 JMP READ50
READ30           ;MFM 512
 LDX #$00
 LDY #$02
 JMP READ50
READ40           ;MFM 1024
 LDX #$00
 LDY #$04
READ50
 STX DXWK1+0     ;TEMP EACH SECTOR CNT
 STY DXWK1+1     ;
;
 STX DPWRK+0     ;TEMP WORK POINTER
 STY DPWRK+1     ;
;
 LDX #0          ;INIT
 LDY #0
 STX DPEND+0     ;TEMP END  POINTER
 STY DPEND+1     ;
;
 LDX CMBRD+6     ;CMD=# OF SECTORS
READ60
 CLC
 LDA DPEND+0     ;DPEND <-- (DPEND)+(DPWRK)
 ADC DPWRK+0
 STA DPEND+0
 LDA DPEND+1
 ADC DPWRK+1
 STA DPEND+1
 DEX             ;END ?
 BNE READ60      ;NO, MORE
;
 CLC
 LDA #<BSTAT     ;DPEND <-- BSTAT +(DPEND)
 ADC DPEND+0
 STA DPEND+0
 LDA #>BSTAT
 ADC DPEND+1
 STA DPEND+1     ;END POINTER SETUP
;
;
 LDX #<BSTAT     ;START POINTER SETUP
 LDY #>BSTAT
 STX DPSTA+0     ;
 STY DPSTA+1     ;
;
 STX RD500+1     ;BUFF TOP ADR SETUP
 STY RD500+2
 LDX #$00        ;//// DEBUG ONLY ///
 LDY #$04        ;SCREEN TOP ADR SETUP
 STX RDEBUG+1
 STY RDEBUG+2
;
;
 JSR OPCMDC      ;OPEN15,8,15
 JSR DELAY       ;DELAY
;
 LDX  #1         ;.X=1 (BURST READ)
 JSR SENCMD      ;SEND COMMAND
;
 JSR CLRCHN      ;SEND EOI
 JSR DELAY       ;DELAY
;
RD100
 SEI             ;
;
 LDX DXWK1+0      ;EACH SECTOR CNT SETUP
 LDY DXWK1+1
 STX DXWK2+0      ;
 STY DXWK2+1
;
;
 BIT D1ICR       ;CLEAR IRQ
 JSR CLKTOG      ;TOGGLE CLK
;
RD200
 LDA D1ICR       ;CHECK SP IRQ
 AND #$08        ;
 BEQ RD200       ;WAIT
;
 LDA D1SDR       ;GET A STATUS BYTE
 STA STAUS       ;PUT
 AND #$0F        ;
 CMP #$02        ;(STATUS)>=2 (ERROR) ?
 BCC RD300       ;NO, 'OK'
 JMP RD750       ;RREAD=1 (ERROR)
;
RD300
 BIT D1ICR       ;CLEAR IRQ
 JSR CLKTOG      ;TOGGLE CLK
;
RD400
 LDA D1ICR       ;CHECK SP IRQ
 AND #$08        ;
 BEQ RD400       ;WAIT
;
 LDA D1SDR       ;**GET A DATA
RD500
 STA $FFFF       ;PUT INTO BUFFER
;
RDEBUG
 STA $FFFF       ;///// DEBUG ONLY (PRINT) ////
;
 CLC
 LDA DPSTA+0     ;END CHECK
 ADC #1          ;DPSTA+1 UP
 STA DPSTA+0
 LDA DPSTA+1     ;
 ADC #0
 STA DPSTA+1
;
 LDA DPSTA+0     ;DPSTA = DPEND ?
 CMP DPEND+0
 BNE RD600       ;NO, LOOP
 LDA DPSTA+1
 CMP DPEND+1
 BEQ RD700       ;YES, END GOTO EXIT
;
RD600
 CLC
 LDA RD500+1     ;BUFF ADR+1 UP
 ADC #1
 STA RD500+1
 LDA RD500+2
 ADC #0
 STA RD500+2
;
 CLC
 LDA RDEBUG+1    ;PRINT ADR+1 UP
 ADC #1
 STA RDEBUG+1
 LDA RDEBUG+2
 ADC #0
 STA RDEBUG+2
;
 SEC
 LDA DXWK2+0     ;DXWK2 - 1 DOWN
 SBC #1
 STA DXWK2+0
 LDA DXWK2+1
 SBC #0
 STA DXWK2+1
 LDA DXWK2+0     ;EACH SECTOR END ?
 ORA DXWK2+1
 BNE RD690       ;NO
;
 JMP RD100       ;YES, RESET DXWK2
;
RD690
 JMP RD300       ;LOOP, READ NEXT DATA
;
;
RD700
 LDA #0          ;RREAD=0 (OK)
 STA RREAD       ;SET
 JMP RD800
RD750
 LDA #1          ;RREAD=1 (ERROR)
 STA RREAD       ;SET
;
RD800
 BIT D1ICR       ;CLR IRQ
 JSR CLKHI       ;RELEASE CLK
 JSR DELAY       ;DELAY
;
 LDA #15         ;CLOSE15
 JSR CLOSE       ;
;
 CLI             ;
 RTS             ;EXIT
;
;
;
; ====================
;      WORK AREA
; ====================
;
DPEND *=*+2      ;WORK:END POINTER
DPSTA *=*+2      ;WORK:START POINTER
DPWRK *=*+2      ;WORK:WORK POINTER
DXWK1 *=*+2      ;WORK:EACH SECTOR SIZE 1
DXWK2 *=*+2      ;WORK:                 2
;
;
;
; ====================
;   READ DATA BUFFER
;  ALLOCATED TO $0B00-
; ====================
;
;BSTAT *=*+128    ;BUFFER START 0-127
;B128  *=*+128    ;128-255
;B256  *=*+256    ;256-511
;B512  *=*+512    ;512-1023
;B1024 *=*+1      ;BUFFER END
.PAGE 'BURST INQUIRE'
; ++++++++++++++++++++++++++++++++++++++++
; +                                      +
; +    BURST INQUIRE SUB                 +
; +                                      +
; +  IN  : IQDSD ... SIDE SEL (MFM)      +
; +                  $00=SIDE0           +
; +                  $10=SIDE1           +
; +                                      +
; +  OUT : DINQ  <-- INQUIRE BYTE        +
; +                                      +
; ++++++++++++++++++++++++++++++++++++++++
;
INQD
 SEI
;
 LDA CMBIQD+3    ;SIDE SEL
 AND #$EF        ;
 ORA IQDSD       ;
 STA CMBIQD+3    ;CMD TBL SET
;
 LDA #$AA        ;CLEAR DINQ AREA
 STA DINQ
;
 JSR OPCMDC      ;OPEN15,8,15
 JSR DELAY       ;DELAY
;
 LDX #3          ;.X=3 (BURST INQUIRE DISK)
 JSR SENCMD      ;SEND CONNAND
;
 JSR CLRCHN      ;SEND EOI
 JSR DELAY       ;DELAY
;
 SEI             ;
 BIT D1ICR       ;CLR IRQ
 JSR CLKTOG      ;TOGGLE CLK
IQ00
 LDA D1ICR       ;CHECK SP IRQ
 AND #$08        ;
 BEQ IQ00        ;WAIT
;
 LDA D1SDR       ;**GET A INQUIRE BYTE
 STA DINQ        ;PUT
;
 NOP             ;
 NOP             ;
 NOP             ;
;
 JSR CLKHI       ;RELEASE CLK
 JSR DELAY       ;DELAY
;
 LDA #15         ;CLOSE15
 JSR CLOSE       ;
;
 CLI
 RTS             ;BACK TO BASIC PROGRAM
.PAGE 'SUB ROUTINES'
; ******************************
; *                            *
; *  BURST SUB ROUTINE BLOCK   *
; *                            *
; ******************************
;
;
;
; ==============================
;      OPEN COMMAND CHANNEL
; ==============================
;
OPCMDC
 LDA #15       ;LA
 LDX #8        ;FA
 LDY #15       ;SA
 JSR SETLFS    ;SETUP LA
;
 LDA #0        ;NO-NAME
 JSR SETNAM    ;SETUP FILE NAME
;
 JSR OPEN      ;OPEN LOGICAL CHANNEL
 RTS           ;EXIT
;
;
;
; ==============================
;       OPEN DATA CHANNEL
; ==============================
;
OPDATC
 LDA #2        ;CHANNEL #2
 LDX #8        ;FA
 LDY #2        ;SA
 JSR SETLFS    ;SETUP LA
;
 LDA #1        ;NAME LENGTH
 LDX #<HASH    ;NAME ADR LO
 LDY #>HASH    ;         HI
 JSR SETNAM    ;SETUP FILE NAME
;
 JSR OPEN      ;OPEN DATA CHANNEL
 RTS           ;EXIT
;
HASH .BYTE  '#' ;NAME
.PAGE
; ==============================
;      SEND COMMAND STRING
; ==============================
;
;
;
; IN  : .X=1   BURST READ
;         =2         WRITE
;         =3         INQUIRE DISK
;         =4         FORMAT MFM
;         =5         SECTOR INTERLEAVE
;         =6         QUERY DISK FORMAT
;         =7         INQUIRE STATUS
;         =8         BACKUP
;         =9         CHANGE UTILITY
;         =10        FAST LOAD
;
;
;
SENCMD
 DEX
 BEQ SMD10    ;1 READ
 DEX
 BEQ SMD20    ;2 WRITE
 DEX
 BEQ SMD30    ;3 INQ DISK
 DEX
 BEQ SMD40    ;4 FORMAT MFM
 DEX
 NOP          ;5 SECTOR INTERLEAVE
 NOP
 DEX
 BEQ SMD50    ;6 QUERY FORMAT
 DEX
 BEQ SMD60    ;7 INQ STATUS (READ/WRITE)
 DEX
 NOP          ;8 BACKUP
 NOP
 DEX
 NOP          ;9 CHANGE UTILITY
 NOP
 DEX
 NOP          ;10 FAST LOAD
 NOP
 JMP SMDEXT   ;ILLEGAL ERROR
;
SMD10
 LDX #<CMBRD  ;CMD BUF TOP ADDR SET
 LDY #>CMBRD
 JMP SMD100   ;GOTO SET
SMD20
 LDX #<CMBWR
 LDY #>CMBWR
 JMP SMD100
SMD30
 LDX #<CMBIQD
 LDY #>CMBIQD
 JMP SMD100
SMD40
 LDX #<CMBFM
 LDY #>CMBFM
 JMP SMD100
SMD50
 LDX #<CMBQY
 LDY #>CMBQY
 JMP SMD100
SMD60
 LDX #<CMBIQS
 LDY #>CMBIQS
 JMP SMD100
SMD70
 LDX #<CMBCHG
 LDY #>CMBCHG
 JMP SMD100
;
SMD100
 STX SBUFR1+1  ;ADDR POINTER SET
 STY SBUFR1+2
;
 STX SBUFR2+1  ;ADDR POINTER SET
 STY SBUFR2+2
;
 LDX #15       ;OPEN CHANNEL FOR OUTPUT
 JSR CHKOUT    ;PRINT#15 *****
;
 CLC
 LDX #0
SBUFR1 LDA $FFFF,X  ;GET CMD LENGTH
 TAY                ;CNT SET
 INX
SBUFR2 LDA $FFFF,X  ;GET CMD STRING
 JSR CHROUT         ;SEND CMD FOR CHANNEL
 INX
 DEY                ;END ?
 BNE SBUFR2         ;NO, MORE
SMDEXT
 RTS                ;EXIT
.PAGE
; ==============================
;      FIRST SERIAL FLAG ON
; ==============================
;
FSERON
 LDA SERIAL
 ORA #%01000000
 STA SERIAL
 RTS
;
;
;
; ==============================
;     FIRST SERIAL FLAG OFF
; ==============================
;
FSEROF
 LDA SERIAL
 AND #%10111111
 STA SERIAL
 RTS
.PAGE
; ==========
;  CLOCK HI
; ==========
;
CLKHI
 LDA D2PRA        ;SERIAL PORT
 CMP D2PRA
 BNE CLKHI
 AND #%11101111   ;CLK (INVERSED)
 STA D2PRA
 RTS
;
;
;
; ==========
;  CLOCK LO
; ==========
;
CLKLO
 LDA D2PRA        ;SERIAL PORT
 CMP D2PRA
 BNE CLKLO
 ORA #%00010000   ;CLK (INVERSED)
 STA D2PRA
 RTS
;
;
;
; ===============
;  TOGGLE CLOCK
; ===============
;
CLKTOG
 LDA D2PRA
 CMP D2PRA
 BNE CLKTOG
 EOR #%00010000    ;TOGGLE
 STA D2PRA
 RTS
.PAGE
; ==============================
;    MMU MODE CONFIG.
;        FSDIR=OUTPUT MODE SET
; ==============================
;
FSDOT
 LDA $D505         ;MMU MODE REG
 ORA #%00001000    ;DIR=OUT
 STA $D505
 RTS
;
;
;
; ==============================
;    MMU MODE CONFIG.
;        FSDIR=INPUT MODE SET
; ==============================
;
FSDIN
 LDA $D505         ;MMU MODE REG
 AND #%11110111    ;DIR=IN
 STA $D505
 RTS
.PAGE
; ==============================
;      6526 SP OUTPUT MODE
; ==============================
;
SPOUT
 LDA D1CRA         ;CRA
 AND #$80          ;SAVE 50/60HZ
 ORA #%01010101    ;SP=OUT,TIMER=FORCE,OUT=TOGGLE,START
 STA D1CRA
 RTS
;
;
;
; ==============================
;      6526 SP INPUT MODE
; ==============================
;
SPINP
 LDA #%00001000    ;SP=IN
 STA D1CRA
 RTS
.PAGE
; ==============================
;      SOME DELAY  (2.5MSEC)
; ==============================
;
DELAY
 PHA
 TXA
 PHA
 TYA
 PHA
;
 LDY #5
DEY10
 LDX #100
DEY20
 DEX         ;2
 BNE DEY20   ;3
 DEY         ;2
 BNE DEY10   ;3
;
 PLA
 TAY
 PLA
 TAX
 PLA
 RTS
.PAGE 'COMMAND TABLE'
; ******************************
; *                            *
; *    COMMAND TABLE BLOCK     *
; *                            *
; ******************************
;
;
;
CMBRD  .BYTE 7   ;1 BURST READ
       .BYTE 'U0',$00,$05,$01,$01,$0A
;
CMBWR  .BYTE 7   ;2 BURST WRITE
       .BYTE 'U0',$02,$05,$01,$01,$0A
;
CMBIQD .BYTE 3   ;3 INQUIRE DISK
       .BYTE 'U0',$04
;
CMBFM  .BYTE 12  ;4 FORMAT MFM
       .BYTE 'U0',$00,$80,0,$01,39,18,0,0,$E5,0
;
CMBITV .BYTE 10  ;5 SECTOR INTERLEAVE
       .BYTE 'U0',$00,$00,$00,$00,$00,$00,$00,$00
;
CMBQY  .BYTE 4   ;6 QUERY DISK FORMAT
       .BYTE 'U0',$0A,$00
;
CMBIQS .BYTE 4   ;7 INQUIRE STATUS (R/W)
       .BYTE 'U0',$00,$00
;
CMBBK  .BYTE 10  ;8 BACKUP
       .BYTE 'U0',$00,$00,$00,$00,$00,$00,$00,$00
;
CMBCHG .BYTE 10  ;9 CHANGE UTILITY
       .BYTE 'U0',$00,$00,$00,$00,$00,$00,$00,$00
;
CMBFS  .BYTE 10  ;10 FAST LOAD
       .BYTE 'U0',$00,$00,$00,$00,$00,$00,$00,$00
.END
