

                            5710 SPECIFICATION

Updated 12/17/85 CH
Updated 1/13/86 CH
Updated 1/25/86 CH

1. DEFINITION

1.1 GENERAL DESCRIPTION

 5710 is the center of the 1571 cost reduction effort.  It will integrate
 the WD1770, 6526, 64H157 gate array, and other glue logic.  It is not
 compatible with the current software, and the high level control function
 of WD1770 is not implemented.  Only a small portion of the 6526 is
 implemented.  The current software to control 6526 might still be applicable,
 but identical timing is not guaranteed.


1.2 PIN CONFIGURATION

 This chip will be in a 48 pin package:
                               _____________
                
		1  FCOB		                   FDOB 48
  		2  TED			           FCIB 47
	        3  PHI0        	                   FDIB 46
	 	4  CLK  		           IRQB 45
	 	5  CTRLO			 RESETB 44
	 	6  CTRLI		  	     NC 43
	 	7  PH2	                             NC	42
	 	8  D7				 INDEXB 41
	 	9  D6	 		            WGB 40
	 	10 D5			          WPRTB 39
		11 D4			         RPULSE 38
		12 VSS	                    	   QOUT	37
		13 VDD  		            VDD	36
 		14 D3	                  	    VSS	35
		15 D2				   CS3B 34
		16 D1			           CS2B 33
		17 D0		 		   CS1B 32
		18 AD15 			    RWB 31
		19 AD14 			 OSCOUT 30
		20 AD13	 		          XTAL2 29
		21 AD12	                	  XTAL1 28
		22 AD10		                    AD0 27
		23 AD4	                            AD1	26
        	24 AD3		                    AD2	25
                               _____________






2. FUNCTIONAL DESCRIPTION

2.1 REGISTER MAP
    (MFM occupies $2000-$4000;  6526 starts at $4000; 
     8x8 RAM follows 6526 registers) 

$2000   MFMREG0
         7           WBYTE  ready to write next byte              (read)
          6          INDEX  disk index flag                       (read)
           5         WRITE  enables write gate                    (read/write)  
            4        NC                                           (read/write)
             3       GEN    starts the CRC generator              (read/write)
              2      DCRC   controls CRC out (hi=data; lo=CRC)    (read/write)
               1     WGON   turns on write gate                   (read/write)
                0    PCE    write precomp enable                  (read/write)

$2001   MFMREG1      D(7:0) write data                            (write)

$2002   MFMREG2 
         7           RBYTE  read byte ready                       (read) 
          6          AMF    AM detect flag                        (read)
           5         SMPL   sample CRC error                      (read/write)
            4        DET    start CRC checker                     (read/write)
             3       CERR   CRC error flag                        (read/write)
              2      NC
               1     NC
                0    NC

$2003   MFMREG3      RD(7:0) read data                            (read)

$2004   MFMREG4      CP(7:0) clock detect pattern                 (read/write)

$2005   MFMREG5      DP(7:0) data detect pattern                  (read/write)

$2006   MFMREG6                                                   
         7           AMGEN   activates missing clock generation   (read/write)
          6          AM2     missing clock generation code        (read/write)
           5         AM1     missing clock generation code        (read/write)
            4        AM0     missing clock generation code        (read/write)
             3       T3      ROM separator data out               (read)
              2      T2      ROM separator data out               (read)
               1     T1      ROM separator data out               (read)
                0    T0      ROM separator data out               (read)

$400C          SDR          Shift data register
                       





$400D          ICR       Interrupt register
               3         SP (READ ONLY).  1 means SP interrupt request.
                         The read operation will clear SP and reset the 
                         IRQ to high.
               7         SCB (WRITE ONLY)
                         1 means setting the Mask to enable IRQB on an SP
                         interrupt.
                         0 will clear the mask and disable IRQB to SP
                         interrupts.
$400E          CRA       Control register (write and read verify)
               6         SPMODE
                         0 = Shift Register Input. 
                         1 = Shift Register Output.  
$4010          RAM LOC0
$4011          RAM LOC1
$4012          RAM LOC2
$4013          RAM LOC3
$4014          RAM LOC4
$4015          RAM LOC5
$4016          RAM LOC6
$4017          RAM LOC7
$1400-$17FF    CS1B
$1C00-$1FFF     "
$0000-$0FFF    CS2B
$6000-$6FFF     "
$1000-$13FF    CS3B
$1800-$1BFF     "





2.2 PIN DESCRIPTION


QTY       NAME           DIR                    DESCRIPTION
----------------------------------------------------------------------------

---------  6502 INTERFACE  --------------
 
8         D0-D7          in/out       Data Bus.

5         AD0-AD4        in           Lower Address Bus.

5         A10,A12-A15    in           Upper Address Bus.

1         RWB            in           Read/_Write control line.

1         RESETB         in           Reset control line.

1         PHI2           in           Phase 2 clock.

1         IRQB           out          Interrupt request line.
                                      Open Collector output.

-----------  DISK INTERFACE ---------------------

1         OSCOUT         out          16 Mhz oscillator output.

2         XTAL1          in           16 Mhz crystal inputs.
          XTAL2 
      
1         WGB            out          Write gate.
                                      Open Collector output.

2         QOUT           out          Write data polarity.
                                      Open Collector output.

1         RPULSE         in           Read pulse.

1         WPRTB          in           Write protect indicator.
                                      Schmidt trigger input.


---------- COMMODORE SERIAL BUS INTERFACE -------------------

1         FAST DATA IN   in           Hardware shift register data input.
          (FDIB)                      Schmidt trigger input.

1         FAST CLK IN    in           Hardware shift register clock input.
          (FCIB)                      Schmidt trigger input.

1         FAST DATA OUT  out          Hardware shift register data output.
          (FDBO)

1         FAST CLK OUT   out          Hardware shift register clock output.
          (FCOB)





---------  GLUE LOGIC ---------------------------------------

1         CS1B           out          Chip select output decoded by
                                      _A15*_A14*_A13*A12*A10

1         CS2B           out          Chip select output decoded by
                                      _A15*_A14*_A13*_A12 + 
                                      _A15*A14*A13*_A12.

1         CS3B           out          Chip select output decoded by
                                      _A15*_A14*_A13*A12*_A10.

1         CTRLI          in           Input control line for 1/2MHZ
                                      switching circuitry.

1         CTRLO          out          Output control line from 1/2MHZ
                                      switching circuitry.

1         CLKIN          in           Input clock to 1/2MHZ switching
                                      circuitry.

1         PHI0           in           Output clock from 1/2MHZ switching
                                      circuitry.

1         TED            in           Output to gate array.

1         PHI1           in           Input clock to generate TED.


--------- SUPPLY  -------------------------------------------

2         VCC            in           +5.

3         GND            in           Ground.








2.3 MAJOR BLOCK DESCRIPTION

2.3.1 Data separator.  

    A ROM based data separator is used. There are two implementations,
    each consists of 32 by 4 bits.  The selections are software programmable.

2.3.2 MFM encoding.

    The encoding function occurs during disk writes. Data is supplied one 
    byte at a time to the parallel to serial converter which feeds the CRC 
    detection/generation unit. Serial data flows through this unit 
    unaltered except for the addition of two CRC bytes appended to the end
    of the serial data stream. This stream then enters the MFM encoder,
    which creates the combination of MFM data and clock. It then enters
    the write pre-compensation circuitry to generate the pulses to the disk. 
    A programmable counter allows a missing clock to be inserted in any bit
    position of the address marks. The microprocess must provide the next
    byte of data within 20us of the WBYTE flag going high.
   
2.3.3 MFM decoding.
      
    The decoding function occurs during disk read.  MFM decoding starts with
    the raw read pulses fed into the data separator. The data separator
    produces a data stream and a timing reference which are fed to the AM
    detect and synchronization unit where the data and clocks emerge completely
    separated. Two 8-bit registers are provided to allow detection of any
    missing clock and data pattern. The serial data stream proceeds through
    the CRC error detector which generates 2 CRC bytes from the read data and
    compares them with the written CRC bytes. If there is a match the data is
    valid; otherwise a CRC error is detected and a flag is set. The serial data
    stream is assembled into bytes by the synchronizer. These bytes can be read
    by the host. The microprocessor must read the data within 20us after the
    RBYTE flag goes active.

2.3.4 Commodore Serial Bus

    Summary:

    In the input mode (SPM=0) the falling edge of the clock applied to pin
    FCIB will latch in the data on FDIB.  After 8 FCIB pulses, the data in the
    shift register is transferred to the SDR and an interrupt is generated
    if SCB is high. If SCB is low no interrupt is generated (i.e. IRQB is high
    whenever SCB is low). IRQB returns high when the SP bit is read. When data
    is transferred to the SDR the SP bit goes high regardless of the value
    of SCB and returns low after it is read.
 
    FCOB and FDOB are both low while SPM is low.

    In the output mode (SPM=1) the byte data loaded into the SDR is shifted
    out (inverted) on pin FDOB on the rising edge of the clock on pin FCOB.
    FCOB has a fixed 50% duty cycle and 6 usec. period. If SCB is set, IRQB will
    go low to whenever a complete byte has been shifted out. If SCB is low, no
    interrupt is generated. In either case, the SP bit goes high when the SDR
    is transferred to the shift register. Reading the SP bit sets IRQB and
    clears SP. Continuous transmission occurs if the SDR is loaded before all
    eight bits are shifted out. If the SDR is not reloaded before all eight
    bits is shifted out, FDOB will freeze the last bit shifted and FCOB will
    remain low. Transmission can be resumed by reloading the SDR.
  
    When SPM is set from low to high, FCOB remains low until the first bit is
    shifted out (approximately 3 usec. later) and FDOB goes high within one
    PH2 cycle.
    
    **************************************************************************
    Register Map:

    400C  Serial Data Register (SDR)
                   db7    db6     db5     db4     db3     db2     db1     db0 
            read   IN7    IN6     IN5     IN4     IN3     IN2     IN1     IN0
           write   OUT7   OUT6    OUT5    OUT4    OUT3    OUT2    OUT1    OUT0

    400D  Interrupt Control Register (ICR)
                   db7    db6     db5     db4     db3     db2     db1     db0 
            read                                  SP
           write   SCB
 
    400E  Control Register A (CRA)
                   db7    db6     db5     db4     db3     db2     db1     db0 
            read          SPM
           write          SPM
    
    **************************************************************************

    Signals:

    FCIB: Active low serial input clock (pin). Clocks FCIB into SDR on falling
          edge when SPM=0. Has no effect when SPM=1.

    FCOB: Active low serial output clock (pin). Rising edges of FCOB shifts
          bits loaded in SDR onto FDOB when SPM=1. Low when SPM=0. 

    FDIB: Active low serial input (pin). Shifted into the Serial Data Register
          (SDR) on the falling edge of FCIB when SPM=0. No effect when SPM=1.

    FDOB: Active low serial output (pin). Bits in SDR are shifted out (MSB
          first and inverted) on FDOB on the rising edge of FCOB when SPM=1.
          Has a fixed period of 6 usec. (PH2/12) and 50% duty cycle. FDOB=0
          when SPM=0. When SPM transitions from 0 to 1, FDOB goes high on
          following PH2 rising edge.

    IRQB: Active low interrupt output (pin). If SCB=1 (interrupt mask) IRQB
          goes low whenever a complete byte is shifted in or shifted out of
          the SDR. IRQB=1 whenever SCB=0. IRQB goes high whenever ICR is read.
 
    SCB:  Interrupt mask (control bit). IRQB is stuck high when SCB=0. IRQB
          goes low on byte shifted in or byte shifted out when SCB=1.

    SP:   Interrupt request flag (status bit). SP goes high whenever a complete
          byte is shifted in or out. SP goes low whenever ICR is read. SCB does
          not affect SP.

    SPM:  Serial port mode (control bit). SPM=0 to shift data on FDIB into SDR
          using FCIB (falling edge) as the clock. SPM=0 forces FCOB and FDOB
          both low. SPM=1 to shift data out of SDR onto FDOB using internally
          generated FCOB (rising edge) as the clock. Rising edge of SPM forces
          FDOB high.








2.3.6 Address decode.   
    It was implemented in 64H157.
 
2.3.7 Saddle canceller.
    It was implemented in 64H157, and the signal will feed to 64H156 for 
    GCR data seperation.

2.3.8 8*8 RAM, the scratch pad for MFM application.

2.3.9 Glue logic.
    This consists of the 1/2MHZ clock switching circuitry for the CPU. 







3. ELECTRICAL REQUIREMENTS

  3.1 ABSOLUTE MAXIMUM RATINGS 

     "Stresses above those listed may cause permanent damage to the
      circuit.  Functional operation of the device at these or any 
      condtions other than those indicated in the operating conditions
      of this specification is not implied.  Exposure to the maximum
      ratings for extended periods may adversely affect device reliability."

 	 characteristic                     min    max   units
	 --------------                    -----  -----  -----
    3.1.1 ambient temperature under bias    -25     +125  deg. c.
    3.1.2 storage temperature               -65     +150  deg. c.
    3.1.3 applied supply voltage            -0.5    +7.0  volts
    3.1.4 applied output voltage            -0.5    +5.5  volts
    3.1.5 applied input  voltage            -2.0    +7.0  volts
    3.1.6 power dissipation                   -      1.0  watt
    3.1.... any other critical rating required, such as maximum
                     output current, minimum load resistance, etc.

  3.2 OPERATING CONDITIONS 

     "All electrical characteristics are specified over the entire 
      range of the operating conditions unless specifically noted.  
      All voltages are referenced to Vss = 0.0V."

	        Condition              Min    Max    Units
	  ------------------------    -----  -----   -----
    3.2.1 Supply voltage (Vcc)         4.5    5.5    volts
    3.2.2 Free air temperature          0      70    Deg. C.
    3.2.3 PH2 Clock time               1 - 2 Mhz +- 100%
                                      with 50% +- 10% duty cycle
    3.2.4 OSC output                    16 Mhz +- 1%
                                      with 50% +- 10% duty cycle
   

  3.3 INTERFACE CHARACTERISTICS 

            Characteristic     Symbol   Min  Max  units      Conditions
	    ------------------ ------   ---  ---  -----    ---------------
   3.3.1    Input high level    Vih     2.0 Vcc   volts  
   3.3.2    Input low  level    Vil    -0.5  0.8  volts
   3.3.3.a  Output high level   Voh     2.4   -   volts      Ioh = -5ma
            (CS1B,CS2B,CS3B,OSCOUT,PHI0,CTRLO)
   3.3.3.b  Output high level   Voh     2.4   -   volts      Ioh = -10ma
            (D7-D0)
   3.3.4.a  Output low level    Vol      -   0.4  volts      Ioh = 3.2ma
            (CS1B,CS2B,CS3B,OSCOUT,PHI0,CTRLO)




   3.3.4.b  Output low level    Vol      -   0.4  volts      Ioh = 4.8ma
            (FCOB,FDOB,IRQB,QOUT,WGB)
   3.3.3.c  Output low level    Vol      -   0.4  volts      Ioh = 6.4ma
            (D7-D0)
   3.3.5 Input  leakage         Iin    -10   10   uamps      0.0v<Vin<Vcc
   3.3.6 Output leakage         Ilkg   -10   10   uamps      0.4v<Vout<2.4v
			                                     (Deselected)
   3.3.7 Supply current         Icc     -   200   mamps      Outputs open
                                                             (Vcc = 5.25V)
	   
  3.4 SWITCHING CHARACTERISTICS 

      Switching characteristics are specified over the full range of 
      operating conditions for input waveforms switching between .4V low
      level and  2.4V high level.  All inputs have rise/fall times from 
      10% to 90% of 10ns.  Outputs are loaded at the rated interface 
      conditions with 100pf total capacitive load (including fixturing).
      All time measurements of driven signals and referenced signal are
      referenced to .6V low and 2.2V high.  
 
           Characteristic      Symbol         min    max  ( ns)
           ______________      ______         ___    ___
    
   3.4.1  PH2 high width        Twph          200
   3.4.2  PH2 low  width        Twpl          200
   3.4.3  Address setup time    Tsad          100
   3.4.4  Address hold time     Tha            10
   3.4.5  Read/write setup time Tsrw          100
   3.4.6  Read/Write hold time  Thrw           10
   3.4.9  Read Data stable      Tdsu           50
   3.4.10 Data hold time-read   Thr            10
   3.4.11 Write Data setup      Tmds          150
   3.4.12 Data hold time-write  Thw            10	


4. MECHANICAL REQUIREMENTS

  4.1 Marking
	  
      Parts shall be marked with Commodore part number, manufacturers
      identification and EIA data code.  Pin 1 shall be identified.

  4.2 PACKAGING

      The circuit shall be packaged in a standard plastic or ceramic 
      48 pin dip with 0.100" pin to pin spacing and 0.600" pin row 
      to pin row spacing.

5.0 APPLICATION GUIDLINES 

